/*
 *************
 * Copyright *
 *************
 *
 * Copyright (C) 2010 Christoph Zauner
 */

/*
 ***********
 * License *
 ***********
 *
 * This file is part of Rihamark.
 * 
 * Rihamark is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Rihamark is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Rihamark.  If not, see <http://www.gnu.org/licenses/>.
 */

package rmk.SPArguments;

import org.simpleframework.xml.*;
import rmk.core.Debug;
import rmk.core.Debug.LogLevel;

/**
 *
 * @author christoph
 */
public class SpinnerInt extends SPArgument {

	@Element private int value;
	
	@Element private String label;
	@Element private int minimum;
	@Element private int maximum;
	@Element private int stepSize;

	public SpinnerInt
	(
			@Element(name="value")int value,
			@Element(name="label")String label,
			@Element(name="minimum")int minimum,
			@Element(name="maximum")int maximum,
			@Element(name="stepSize")int stepSize
	)
	{
		Debug.debugPrint(LogLevel.DEBUG2, "Constructor in SpinnerInt (project rmk-core)");

		this.value = value;
		this.label = label;
		this.minimum = minimum;
		this.maximum = maximum;
		this.stepSize = stepSize;
	}

	/**
	 * @return the label
	 */
	public String getLabel() {
		return label;
	}

	/**
	 * @param label the label to set
	 */
	public void setLabel(String label) {
		this.label = label;
	}

	/**
	 * @return the minimum
	 */
	public int getMinimum() {
		return minimum;
	}

	/**
	 * @param minimum the minimum to set
	 */
	public void setMinimum(int minimum) {
		this.minimum = minimum;
	}

	/**
	 * @return the maximum
	 */
	public int getMaximum() {
		return maximum;
	}

	/**
	 * @param maximum the maximum to set
	 */
	public void setMaximum(int maximum) {
		this.maximum = maximum;
	}

	/**
	 * @return the step
	 */
	public int getStepSize() {
		return stepSize;
	}

	/**
	 * @param step the step to set
	 */
	public void setStepSize(int stepSize) {
		this.stepSize = stepSize;
	}

	/**
	 * @return the value
	 */
	public int getValue() {
		return value;
	}

	/**
	 * @param value the value to set
	 */
	public void setValue(int value) {
		this.value = value;
	}

} // end of class

