/*
 *************
 * Copyright *
 *************
 *
 * Copyright (C) 2010 Christoph Zauner
 */

/*
 ***********
 * License *
 ***********
 *
 * This file is part of Rihamark.
 * 
 * Rihamark is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Rihamark is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Rihamark.  If not, see <http://www.gnu.org/licenses/>.
 */

package rmk.SPMenu;

import javax.swing.JFrame;
import rmk.core.TestPlan;

/**
 * Used by plugins to communicate with a user interface.
 * Each user interface that wants to facilitate Swing plugins
 * has to implement this interface.
 *
 * @author Christoph Zauner
 */
public interface UserInterface {

	/**
	 * @return the main frame of the user interface
	 */
	public JFrame getMainFrame();

	/**
	 * @return the active test plan
	 */
	public TestPlan getTestPlan();

}  // end of class
