/*
 *************
 * Copyright *
 *************
 *
 * Copyright (C) 2010 Christoph Zauner
 */

/*
 ***********
 * License *
 ***********
 *
 * This file is part of Rihamark.
 * 
 * Rihamark is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Rihamark is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Rihamark.  If not, see <http://www.gnu.org/licenses/>.
 */

package rmk.core;

/**
 * The Core uses this class to signal the user 
 * interface various events.
 *
 * @author Christoph Zauner
 */
public interface TaskReport {

	/**
	 * Used to signal that the task has finished.
	 *
	 * @param finishedSuccessfully
	 *        {@code true} if the task has finished
	 *        successfully; otherwise {@code false}
	 */
	public void reportFinished(boolean finishedSuccessfully);

	/**
	 * Used to report the progress in terms of
	 * completed jobs.
	 *
	 * @param progress
	 *        the progress the task is now at
	 */
	public void reportProgress(int progress);

} // end of class
