/*
 *************
 * Copyright *
 *************
 *
 * Copyright (C) 2010 Christoph Zauner
 */

/*
 ***********
 * License *
 ***********
 *
 * This file is part of Rihamark.
 * 
 * Rihamark is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Rihamark is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Rihamark.  If not, see <http://www.gnu.org/licenses/>.
 */

package rmk.core;

import java.io.File;
import java.util.LinkedList;

import org.simpleframework.xml.*;

import rmk.SPInterfaces.*;


public class Test {

	@ElementList
	private LinkedList<Algorithm> algorithmsToRun = new LinkedList<Algorithm>();
	@ElementList
	private LinkedList<Attack> attacksToRun = new LinkedList<Attack>();
	@Element
	private String imageAttackDir =  System.getProperty("java.io.tmpdir") + File.separator + "rihamark_attacked";
	@Element
	private String imageDir =  System.getProperty("java.io.tmpdir") + File.separator + "rihamark_originals";
	@Attribute
	private String testName = "Name of Test";
	@Element
	public String testType = "Intra";
	@Element
	public boolean processAttackChain = true;
	@Element
	public boolean fastInterTest = true;

	private LinkedList<Run> runs = new LinkedList<Run>();

	@Override
	public String toString() {
		return getTestName();
	}
	

	/*****************************/
	/* getter and setter methods */
	/*****************************/


	public String getTestName() {
		return this.testName;
	}

	public String getImageDir() {
		return this.imageDir;
	}

	public void setImageDir(String imageDir) {
		this.imageDir = imageDir;
	}

	public String getImageAttackDir() {
		return this.imageAttackDir;
	}

	public void setImageAttackDir(String imageTmpDir) {
		this.imageAttackDir = imageTmpDir;
	}

	public void setTestName(String testName) {
		this.testName = testName;
	}

    /**
     * @return the attacksToRun
     */
    public LinkedList<Attack> getAttacksToRun() {
		return attacksToRun;
    }

    /**
     * @param attacksToRun the attacksToRun to set
     */
    public void setAttacksToRun(LinkedList<Attack> attacksToRun) {
		this.attacksToRun = attacksToRun;
    }

	/**
	 * @return the algorithmsToRun
	 */
	public LinkedList<Algorithm> getAlgorithmsToRun() {
		return algorithmsToRun;
	}

	/**
	 * @param algorithmsToRun the algorithmsToRun to set
	 */
	public void setAlgorithmsToRun(LinkedList<Algorithm> algorithmsToRun) {
		this.algorithmsToRun = algorithmsToRun;
	}

	/**
	 * @return the runs
	 */
	public LinkedList<Run> getRuns() {
		return runs;
	}

	/**
	 * @param runs the runs to set
	 */
	public void setRuns(LinkedList<Run> runs) {
		this.runs = runs;
	}

	/**
	 * @return the processAttackChain
	 */
	public boolean isProcessAttackChain() {
		return processAttackChain;
	}

	/**
	 * @param processAttackChain the processAttackChain to set
	 */
	public void setProcessAttackChain(boolean processAttackChain) {
		this.processAttackChain = processAttackChain;
	}

	/**
	 * @return the fastInterTest
	 */
	public boolean isFastInterTest() {
		return fastInterTest;
	}

	/**
	 * @param fastInterTest the fastInterTest to set
	 */
	public void setFastInterTest(boolean fastInterTest) {
		this.fastInterTest = fastInterTest;
	}

} // end of classs
