/*
 *************
 * Copyright *
 *************
 *
 * Copyright (C) 2010 Christoph Zauner
 */

/*
 ***********
 * License *
 ***********
 *
 * This file is part of Rihamark.
 * 
 * Rihamark is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Rihamark is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Rihamark.  If not, see <http://www.gnu.org/licenses/>.
 */

package rmk.plugins.attacks.java;

import java.util.ArrayList;

import rmk.SPInterfaces.*;
import rmk.SPArguments.*;
import org.simpleframework.xml.*;

/**
 *
 * @author christoph
 */
public class Scale extends Attack {

	/* start: mandatory service provider variables */
	private static String name = "Scale (not implemented yet)";
	private static String bundleName = "Rihamark Default Attack Plugins (using Java)";
	private static String description = "Self explanatory.";
	/* end: mandatory service provider variables */

	/* start: service provider options */
	@Element private Double xScale = 0.5;
	@Element private Double yScale = 0.5;
	@Element private String interpolation = "None";
	/* end: service provider options */

	public Scale() {
		super(name, bundleName, description);

		if(!deserialization) {
			// argument
			addSPArgument(new SpinnerDbl(xScale, "X Scale", 0, 100, 0.1));

			// argument
			addSPArgument(new SpinnerDbl(yScale, "Y Scale", 0, 100, 0.1));

			// argument
			String[] items = {"None", "Bilinear", "Bicubic"};
			addSPArgument(new ComboBox(interpolation, "Interpolation", items));
		}
	}

	public void runAttack(String pathImageAttackDir) {

	}

	
	/*****************************/
	/* getter and setter methods */
	/*****************************/

	
} // end of class
