/*
 *************
 * Copyright *
 *************
 *
 * Copyright (C) 2010 Christoph Zauner
 */

/*
 ***********
 * License *
 ***********
 *
 * This file is part of Rihamark.
 * 
 * Rihamark is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Rihamark is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Rihamark.  If not, see <http://www.gnu.org/licenses/>.
 */

package rmk.plugins.attacks.misc;

import rmk.core.Debug;
import java.util.ArrayList;
import rmk.SPArguments.Label;
import rmk.SPArguments.SPArgument;
import rmk.SPInterfaces.Attack;

/**
 * An attack that does nothing. It can be used for testing purposes.
 */
public class Empty extends Attack {

	/* start: mandatory service provider variables */
	private static String name = "Empty";
	private static String bundleName = "Rihamark Default Attack Plugins (using Java)";
	private static String description = "An attack that does nothing. For testing purposes.";
	/* end: mandatory service provider variables */

	/* start: service provider options */
	private String label = "This is a test attack plugin which performs nothing.";
	/* end: service provider options */

	public Empty() {
		super(name, bundleName, description);
	    Debug.debugPrint(Debug.LogLevel.DEBUG2, "Constructor AttackEmpty");

		if(!deserialization) {
			// argument
			addSPArgument(new Label(label));
		}
	}

    public void runAttack(String pathImageAttackDir){
	    Debug.debugPrint("Running attack: " + getName());
	}


	/*****************************/
	/* getter and setter methods */
	/*****************************/


} // end of class
